package com.tzld.piaoquan.recommend.feature.domain.ad.base;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;


@Getter
@NoArgsConstructor
public class AdItemFeature {
    @Setter
    private String adId = "0";

    @Setter
    private String adCode = "0";

    @Setter
    private String advertiserId = "0";
    @Setter
    private String advertiserCode = "0";

    @Setter
    private String campaignId = "0";

    @Setter
    private String campaignCode = "0";

    @Setter
    private String creativeId = "0";

    @Setter
    private String creativeCode = "0";


    // adid 计划维度统计信息
    // 当天统计量信息
    @Setter
    private AdActionFeature day1_cnt_features = new AdActionFeature();
    // 3天内统计量
    @Setter
    private AdActionFeature day3_cnt_features = new AdActionFeature();
    // 7天内统计量
    @Setter
    private AdActionFeature day7_cnt_features = new AdActionFeature();
    // 3个月统计量
    @Setter
    private AdActionFeature month3_cnt_features = new AdActionFeature();


    // 创意维度统计信息
    @Setter
    private AdActionFeature creative_1day_cnt_features = new AdActionFeature();
    @Setter
    private AdActionFeature creative_3day_cnt_features = new AdActionFeature();
    @Setter
    private AdActionFeature creative_7day_cnt_features = new AdActionFeature();
    @Setter
    private AdActionFeature creative_3month_cnt_features = new AdActionFeature();

    // 广告主维度统计信息
    @Setter
    private AdActionFeature advertiser_1day_cnt_features = new AdActionFeature();
    @Setter
    private AdActionFeature advertiser_3day_cnt_features = new AdActionFeature();
    @Setter
    private AdActionFeature advertiser_7day_cnt_features = new AdActionFeature();
    @Setter
    private AdActionFeature advertiser_3month_cnt_features = new AdActionFeature();


    public void setAdId(String key) {
        if (key == null) {
            this.adId = "0";
        } else {
            this.adId = key;
        }
    }


    public void setAdvertiserId(String key) {
        if (key == null) {
            this.advertiserId = "0";
        } else {
            this.advertiserId = key;
        }
    }

    public void setCampaignId(String key) {
        if (key == null) {
            this.campaignId = "0";
        } else {
            this.campaignId = key;
        }
    }


    public void setCreativeId(String key) {
        if (key == null) {
            this.creativeId = "0";
        } else {
            this.creativeId = key;
        }
    }


    //creative
    public void setCreative_1day_cnt_features(AdActionFeature feature) {
        this.creative_1day_cnt_features = feature;
    }


    public void setCreative_3day_cnt_features(AdActionFeature feature) {
        this.creative_3day_cnt_features = feature;

    }

    public void setCreative_7day_cnt_features(AdActionFeature feature) {
        this.creative_7day_cnt_features = feature;

    }

    public void setCreative_3month_cnt_features(AdActionFeature feature) {
        this.creative_3month_cnt_features = feature;

    }


    // advertiser 维度
    public void setAdvertiser_1day_cnt_features(AdActionFeature feature) {
        this.advertiser_1day_cnt_features = feature;
    }


    public void setAdvertiser_3day_cnt_features(AdActionFeature feature) {
        this.advertiser_3day_cnt_features = feature;

    }

    public void setAdvertiser_7day_cnt_features(AdActionFeature feature) {
        this.advertiser_7day_cnt_features = feature;

    }

    public void setAdvertiser_3month_cnt_features(AdActionFeature feature) {
        this.advertiser_3month_cnt_features = feature;

    }


    public String getKey() {
        return this.creativeId;
    }

    public String getValue() {
        Gson gson = new GsonBuilder().serializeSpecialFloatingPointValues().create();
        return gson.toJson(this);
    }


}
