package com.tzld.piaoquan.recommend.feature.domain.ad.base;

import lombok.Data;

import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;


@Data
public class AdRankItem implements Comparable<AdRankItem> {
    public long adId;
    private double score; // 记录最终的score
    // 随机值，当score相等时 根据random排序。避免相同分数的CID，一直只出一个的情况
    private int random;

    // 预估计算结果
    private double ctr;
    private double cvr;
    private double ecpm1;
    private double ecpm2;
    private double str;
    private double ros;
    private double breakRate;
    private double lrScore;
    private double adDirectionScore;

    // 增加tf打分
    private double tf_ctr;
    private double tf_cvr;
    private double score_type;

    // 初始传入
    private double bid1;
    private double bid2;
    private double pidLambda;

    private double cpa;
    private double weight;
    private double cpm;

    // 记录Item侧用到的特征
    private AdItemFeature itemFeature;
    private String lrSampleString = "";
    private String lrSampleStringOrgin = "";

    // 联盟参数
    private Long mediaId;

    private Long videoId;

    private String creativeCode;

    // 广告主ID
    private String adVerId;
    // 计划id
    private Long campaignId;
    // 广告id
    private Long id;

    // 特征
    private Map<String, Object> ext = new HashMap<>();

    private Map<String, String> featureMap = new ConcurrentHashMap<>();

    private Map<String, Map<String, String>> metaFeatureMap = new HashMap<>();

    public AdRankItem() {
        // TODO
    }

    private Map<String, Double> rankerScore = new HashMap<>();
    private Map<String, Integer> rankerIndex = new HashMap<>();
    private Map<String, Double> scoreMap = new HashMap<>();

    @Override
    public int compareTo(AdRankItem o) {
        if (o == null) {
            return -1;
        }
        if (score > o.score) {
            return -1;
        } else if (score < o.score) {
            return 1;
        } else {
            return 0;
        }
    }


}
