package com.tzld.piaoquan.recommend.feature.domain.ad.base;


import lombok.Data;

@Data
public class AdRequestContextBytesFeature {
    private final byte[] apptype;
    private final byte[] machineinfo_brand;
    private final byte[] machineinfo_model;
    private final byte[] machineinfo_sdkversion;
    private final byte[] machineinfo_wechatversion;

    // 时间等信息
    private final byte[] day;
    private final byte[] week;
    private final byte[] hour;
    private final byte[] region;
    private final byte[] city;


    public AdRequestContextBytesFeature(AdRequestContext requestContext) {
        apptype = requestContext.getApptype().getBytes();
        machineinfo_brand = requestContext.getMachineinfoBrand().getBytes();
        machineinfo_model = requestContext.getMachineinfoModel().getBytes();
        machineinfo_sdkversion = requestContext.getMachineinfoSdkversion().getBytes();
        machineinfo_wechatversion = requestContext.getMachineinfoWechatversion().getBytes();

        day = requestContext.getDay().getBytes();
        week = requestContext.getWeek().getBytes();
        hour = requestContext.getHour().getBytes();
        region = requestContext.getRegion().getBytes();
        city = requestContext.getCity().getBytes();

        // headVideoId = requestContext.getHeadVideoId().getBytes();
        // pageSource = requestContext.getPageSource().getBytes();
        // ownAdPositionId = requestContext.getOwnAdPositionId().getBytes();
    }


}
