package com.tzld.piaoquan.recommend.feature.domain.ad.base;

import lombok.Data;

import java.util.HashMap;
import java.util.Map;

@Data
public class UserAdBytesFeature {

    private final byte[] mid;

    // 当天统计量信息
    private Map<String, byte[]> day1_cnt_features;
    // 3天内统计量
    private Map<String, byte[]> day3_cnt_features;
    // 7天内统计量
    private Map<String, byte[]> day7_cnt_features;
    // 3个月统计量
    private Map<String, byte[]> month3_cnt_features;

    private static void addAdActionFeature(Map<String, byte[]>  dayCntMap, AdActionFeature adActionFeature ){

        dayCntMap.put("view", String.valueOf(ceilLog(adActionFeature.getAdView())).getBytes());
        dayCntMap.put("click", String.valueOf(ceilLog(adActionFeature.getAdClick())).getBytes());
        dayCntMap.put("conversion", String.valueOf(ceilLog(adActionFeature.getAdConversion())).getBytes());
        dayCntMap.put("ctr", String.valueOf(bucketRatioFeature(adActionFeature.getCtr())).getBytes());
        dayCntMap.put("cvr", String.valueOf(bucketRatioFeature(adActionFeature.getCvr())).getBytes());
    }

    private static double ceilLog(Double key) {
        return Math.ceil(Math.log(key + 1));
    }

    private static double bucketRatioFeature(Double key) {
        long bucket = Math.round(Math.log((key + 1) * 50));
        if (bucket > 50)
            bucket = 50;
        return (double) bucket;
    }




    public UserAdBytesFeature(UserAdFeature feature) {
        this.mid = feature.getMid().getBytes();

        // 1 day statistic
        day1_cnt_features = new HashMap<String, byte[]>();
        addAdActionFeature(day1_cnt_features, feature.getDay1_cnt_features());

        // 3 day statistic
        day3_cnt_features = new HashMap<String, byte[]>();
        addAdActionFeature(day3_cnt_features, feature.getDay3_cnt_features());

        // 7 day statistic
        day7_cnt_features = new HashMap<String, byte[]>();
        addAdActionFeature(day7_cnt_features, feature.getDay7_cnt_features());


        // 3 month statisic
        month3_cnt_features = new HashMap<String, byte[]>();
        addAdActionFeature(month3_cnt_features, feature.getMonth3_cnt_features());

    }
}
