package com.tzld.piaoquan.recommend.feature.domain.video.base;

import lombok.Data;

import java.lang.Math;

@Data
public class UserActionFeature {
    private double exp_cnt = 0d;
    private double click_cnt = 0d;
    private double share_cnt = 0d;
    private double return_cnt = 0d;

    private double ctr = 0d;
    private double str = 0d;
    private double rov = 0d;
    private double ros = 0d;

    private double ceilLog(Double key) {
        return Math.ceil(Math.log(key + 1));
    }

    private double bucketRatioFeature(Double key) {
        long bucket = Math.round(Math.log((key + 1) * 50));
        if (bucket > 50)
            bucket = 50;
        return (double) bucket;
    }


    public void setExp_cnt(Object key) {
        if (key == null) {
            this.exp_cnt = 0.0;
        } else {
            String formateKey = key.toString().replace("\\N", "0");
            this.exp_cnt = ceilLog(Double.valueOf(formateKey));
        }
    }

    public void setClick_cnt(Object key) {
        if (key == null) {
            this.click_cnt = 0.0;
        } else {
            String formateKey = key.toString().replace("\\N", "0");
            this.click_cnt = ceilLog(Double.valueOf(formateKey));
        }
    }

    public void setShare_cnt(Object key) {
        if (key == null) {
            this.share_cnt = 0.0;
        } else {
            String formateKey = key.toString().replace("\\N", "0");
            this.share_cnt = ceilLog(Double.valueOf(formateKey));
        }
    }

    public void setReturn_cnt(Object key) {
        if (key == null) {
            this.return_cnt = 0.0;
        } else {
            String formateKey = key.toString().replace("\\N", "0");
            this.return_cnt = ceilLog(Double.valueOf(formateKey));
        }
    }

    public void setCtr(Object key) {
        if (key == null) {
            this.ctr = 0.0;
        } else {
            String formateKey = key.toString().replace("\\N", "0");
            this.ctr = bucketRatioFeature(Double.valueOf(formateKey));
        }
    }

    public void setStr(Object key) {
        if (key == null) {
            this.str = 0.0;
        } else {
            String formateKey = key.toString().replace("\\N", "0");
            this.str = bucketRatioFeature(Double.valueOf(formateKey));
        }
    }

    public void setRov(Object key) {
        if (key == null) {
            this.rov = 0.0;
        } else {
            String formateKey = key.toString().replace("\\N", "0");
            this.rov = bucketRatioFeature(Double.valueOf(formateKey));
        }
    }

    public void setRos(Object key) {
        if (key == null) {
            this.ros = 0.0;
        } else {
            String formateKey = key.toString().replace("\\N", "0");
            this.ros = bucketRatioFeature(Double.valueOf(formateKey));
        }
    }


    public void setOriginExp_cnt(Object key) {
        if (key == null) {
            this.exp_cnt = 0.0;
        } else {
            String formateKey = key.toString().replace("\\N", "0");
            this.exp_cnt = Double.valueOf(formateKey);
        }
    }

    public void setOriginClick_cnt(Object key) {
        if (key == null) {
            this.click_cnt = 0.0;
        } else {
            String formateKey = key.toString().replace("\\N", "0");
            this.click_cnt = Double.valueOf(formateKey);
        }
    }

    public void setOriginShare_cnt(Object key) {
        if (key == null) {
            this.share_cnt = 0.0;
        } else {
            String formateKey = key.toString().replace("\\N", "0");
            this.share_cnt = Double.valueOf(formateKey);
        }
    }

    // redis中保存原始值  server段统一处理
    public void setOriginReturn_cnt(Object key) {
        if (key == null) {
            this.return_cnt = 0.0;
        } else {
            String formateKey = key.toString().replace("\\N", "0");
            this.return_cnt = Double.valueOf(formateKey);
        }
    }

    public void setOriginCtr(Object key) {
        if (key == null) {
            this.ctr = 0.0;
        } else {
            String formateKey = key.toString().replace("\\N", "0");
            this.ctr = Double.valueOf(formateKey);
        }
    }


    public void setOriginStr(Object key) {
        if (key == null) {
            this.str = 0.0;
        } else {
            String formateKey = key.toString().replace("\\N", "0");
            this.str = Double.valueOf(formateKey);
        }
    }

    public void setOriginRov(Object key) {
        if (key == null) {
            this.rov = 0.0;
        } else {
            String formateKey = key.toString().replace("\\N", "0");
            this.rov = Double.valueOf(formateKey);
        }
    }


    public void setOriginRos(Object key) {
        if (key == null) {
            this.ros = 0.0;
        } else {
            String formateKey = key.toString().replace("\\N", "0");
            this.ros = Double.valueOf(formateKey);
        }
    }


}
