package com.tzld.piaoquan.recommend.feature.domain.video.base;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import lombok.Getter;
import lombok.NoArgsConstructor;

@Getter
@NoArgsConstructor
public class UserFeature {

    private String uid = "0";
    private String mid = "0";
    // 当天统计量信息
    private UserActionFeature day1_cnt_features;
    // 3天内统计量
    private UserActionFeature day3_cnt_features;
    // 7天内统计量
    private UserActionFeature day7_cnt_features;
    // 3个月统计量
    private UserActionFeature month3_cnt_features;
    // 用户行为周期
    private String user_cycle_bucket_7days = "0";
    private String user_cycle_bucket_30days = "0";
    private String user_share_bucket_30days = "0";

    public void setUid(String key) {
        this.uid = key;
        if (key == null)
            this.uid = "0";
    }

    public void setMid(String key) {
        this.uid = key;
        if (key == null)
            this.uid = "0";
    }


    public void setDay1_cnt_features(UserActionFeature key) {
        this.day1_cnt_features = key;
        if (key == null)
            this.day1_cnt_features = new UserActionFeature();
    }

    public void setDay3_cnt_features(UserActionFeature key) {
        this.day3_cnt_features = key;
        if (key == null)
            this.day3_cnt_features = new UserActionFeature();
    }

    public void setDay7_cnt_features(UserActionFeature key) {
        this.day7_cnt_features = key;
        if (key == null)
            this.day7_cnt_features = new UserActionFeature();
    }

    public void setMonth3_cnt_features(UserActionFeature key) {
        this.month3_cnt_features = key;
        if (key == null)
            this.month3_cnt_features = new UserActionFeature();
    }


    public void setUser_cycle_bucket_7days(String key) {
        this.user_cycle_bucket_7days = key;
        if (key == null)
            this.user_cycle_bucket_7days = "0";
    }

    public void setUser_cycle_bucket_30days(String key) {
        this.user_cycle_bucket_30days = key;
        if (key == null)
            this.user_cycle_bucket_30days = "0";
    }

    public void setUser_share_bucket_30days(String key) {
        this.user_share_bucket_30days = key;
        if (key == null)
            this.user_share_bucket_30days = "0";
    }


    public String getKey() {
        return this.mid;
    }

    public String getValue() {
        Gson gson = new GsonBuilder().serializeSpecialFloatingPointValues().create();
        return gson.toJson(this);
    }

    public static UserFeature defaultInstance(String mid) {
        UserFeature userFeature = new UserFeature();
        userFeature.setMid(mid);
        userFeature.setUser_share_bucket_30days(null);
        userFeature.setUser_cycle_bucket_30days(null);
        userFeature.setUser_cycle_bucket_7days(null);
        userFeature.setMonth3_cnt_features(null);
        userFeature.setDay7_cnt_features(null);
        userFeature.setDay3_cnt_features(null);
        userFeature.setDay1_cnt_features(null);
        return userFeature;
    }

}
