package com.tzld.piaoquan.recommend.feature.produce;

import com.tzld.piaoquan.recommend.feature.produce.service.OSSService;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang.math.NumberUtils;
import org.apache.commons.lang3.StringUtils;
import org.apache.spark.SparkConf;
import org.apache.spark.api.java.JavaRDD;
import org.apache.spark.api.java.JavaSparkContext;

import java.util.ArrayList;
import java.util.List;

/**
 * @author dyp
 */
@Slf4j
public class VideoCleanExecutor {
    public static void main(String[] args) {
        String file = args[0];
        int repartition = NumberUtils.toInt(args[1], 160);
        int sync = NumberUtils.toInt(args[2], 0);


        log.info("hdfs file {}", file);
        SparkConf sparkConf = new SparkConf()
                //.setMaster("local")
                .setAppName("VideoCleanExecutor");
        JavaSparkContext jsc = new JavaSparkContext(sparkConf);

        JavaRDD<String> multiFileRDD = jsc.textFile(file);

        log.info("count {}", multiFileRDD.count());
        OSSService ossService = new OSSService();
        multiFileRDD.repartition(repartition).foreachPartition(s -> {
            List<String> objectNames = new ArrayList<>();
            while (s.hasNext()) {
                String[] data = StringUtils.split(s.next(), "\t");
                objectNames.add(data[2]);
            }
            if (sync == 1) {
                ossService.transToDeepColdArchive("art-pubbucket", objectNames);
            } else {
                ossService.transToDeepColdArchive2("art-pubbucket", objectNames);
            }
        });
    }

}