package com.tzld.piaoquan.recommend.feature.produce;

import com.tzld.piaoquan.recommend.feature.produce.service.HDFSService;
import com.tzld.piaoquan.recommend.feature.produce.service.ODPSService;
import lombok.extern.slf4j.Slf4j;
import org.apache.spark.SparkConf;
import org.apache.spark.api.java.JavaRDD;
import org.apache.spark.api.java.JavaSparkContext;

import java.util.Map;

/**
 * @author dyp
 */
@Slf4j
public class VideoCleanODPSToHDFS {
    public static void main(String[] args) {

        String path = "/dyp/oss/video_clean/";
        try {
            HDFSService hdfsService = new HDFSService();
            hdfsService.delete(path);
        } catch (Exception e) {
            log.info("hdfs error ", e);
        }

        SparkConf sparkConf = new SparkConf()
                //.setMaster("local")
                .setAppName("VideoCleanODPSToHDFS");
        JavaSparkContext jsc = new JavaSparkContext(sparkConf);

        ODPSService odpsService = new ODPSService();
        JavaRDD<Map<String, String>> record = odpsService.read(jsc, "loghubods", "not_active_videos_di", "dt=20240617",
                90);

        JavaRDD<String> data = record.map(r -> {
            StringBuilder sb = new StringBuilder();
            sb.append(r.get("videoid"));
            sb.append("\t");
            sb.append(r.get("video_path"));
            sb.append("\t");
            sb.append(r.get("transed_video_path"));
            sb.append("\t");
            sb.append(r.get("cover_img_path"));
            sb.append("\t");
            sb.append(r.get("self_cover_img_path"));
            sb.append("\t");
            sb.append(r.get("share_moment_img_path"));
            return sb.toString();
        });

        data.coalesce(90).saveAsTextFile(path);
    }

}
