package com.tzld.piaoquan.recommend.feature.produce.service;

import com.aliyun.oss.OSS;
import com.aliyun.oss.OSSClientBuilder;
import com.aliyun.oss.model.CopyObjectRequest;
import com.aliyun.oss.model.CopyObjectResult;
import com.aliyun.oss.model.ObjectMetadata;
import lombok.extern.slf4j.Slf4j;

import java.io.Serializable;
import java.util.List;
import java.util.concurrent.CountDownLatch;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;

/**
 * @author dyp
 */
@Slf4j
public class OSSService implements Serializable {
    private String accessId = "LTAI5tHMkNaRhpiDB1yWMZPn";
    private String accessKey = "XLi5YUJusVwbbQOaGeGsaRJ1Qyzbui";
    private String endpoint = "https://oss-cn-hangzhou-internal.aliyuncs.com";

    public void transToDeepColdArchive(String bucketName, List<String> objectNames) {
        OSS ossClient = new OSSClientBuilder().build(endpoint, accessId, accessKey);
        for (String objectName : objectNames) {
            try {
                if (objectName.startsWith("http")) {
                    continue;
                }
                CopyObjectRequest request = new CopyObjectRequest(bucketName, objectName, bucketName, objectName);
                ObjectMetadata objectMetadata = new ObjectMetadata();
                objectMetadata.setHeader("x-oss-storage-class", "DeepColdArchive");
                request.setNewObjectMetadata(objectMetadata);
                CopyObjectResult result = ossClient.copyObject(request);
            } catch (Exception e) {
                log.error("transToDeepColdArchive error {} {}", objectName, e.getMessage(), e);
            }
        }
        if (ossClient != null) {
            ossClient.shutdown();
        }
    }

    public void transToDeepColdArchive2(String bucketName, List<String> objectNames) {
        OSS ossClient = new OSSClientBuilder().build(endpoint, accessId, accessKey);
        CountDownLatch cdl = new CountDownLatch(objectNames.size());
        ExecutorService es = Executors.newFixedThreadPool(3);
        for (String objectName : objectNames) {
            es.submit(() -> {
                try {
                    if (!objectName.startsWith("http")) {
                        CopyObjectRequest request = new CopyObjectRequest(bucketName, objectName, bucketName, objectName);
                        ObjectMetadata objectMetadata = new ObjectMetadata();
                        objectMetadata.setHeader("x-oss-storage-class", "DeepColdArchive");
                        request.setNewObjectMetadata(objectMetadata);
                        ossClient.copyObject(request);
                    }
                } catch (Exception e) {
                    log.error("transToDeepColdArchive error {} {}", objectName, e.getMessage(), e);
                }
                cdl.countDown();
            });
        }
        try {
            cdl.await(1, TimeUnit.HOURS);
        } catch (InterruptedException e) {
            log.error("transToDeepColdArchive error", e);
        }
        if (ossClient != null) {
            ossClient.shutdown();
        }
    }
}
