package com.tzld.piaoquan.recommend.feature;

import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.autoconfigure.data.redis.RedisReactiveAutoConfiguration;
import org.springframework.cloud.netflix.eureka.EnableEurekaClient;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.EnableAspectJAutoProxy;

/**
 * https://github.com/grpc-swagger/grpc-swagger/blob/master/README_CN.md
 */
@SpringBootApplication(exclude = {
        RedisReactiveAutoConfiguration.class
})
@ComponentScan({
        "com.tzld.piaoquan.recommend.feature.service",
        "com.tzld.piaoquan.recommend.feature.grpcservice",
        "com.tzld.piaoquan.recommend.feature.web",
        "com.tzld.piaoquan.recommend.feature.config"
})
@EnableEurekaClient
@EnableAspectJAutoProxy
public class Application {
    public static void main(String[] args) {
        SpringApplication.run(Application.class, args);
    }
}
