package com.tzld.piaoquan.recommend.feature.grpcservice;

import com.tzld.piaoquan.recommend.feature.client.ProtobufUtils;
import com.tzld.piaoquan.recommend.feature.model.feature.FeatureV2ServiceGrpc;
import com.tzld.piaoquan.recommend.feature.model.feature.MultiGetFeatureRequest;
import com.tzld.piaoquan.recommend.feature.model.feature.MultiGetFeatureResponse;
import com.tzld.piaoquan.recommend.feature.service.FeatureV2Service;
import io.grpc.stub.StreamObserver;
import lombok.extern.slf4j.Slf4j;
import net.devh.boot.grpc.server.service.GrpcService;
import org.springframework.beans.factory.annotation.Autowired;

/**
 * @author dyp
 */
@GrpcService
@Slf4j
public class FeatureV2GrpcService extends FeatureV2ServiceGrpc.FeatureV2ServiceImplBase {

    @Autowired
    private FeatureV2Service featureV2Service;

    @Override
    public void multiGetFeature(MultiGetFeatureRequest request,
                                StreamObserver<MultiGetFeatureResponse> responseObserver) {
        //log.info("FeatureV2GrpcService multiGetFeature request={}", ProtobufUtils.toJson(request));
        MultiGetFeatureResponse response = featureV2Service.multiGetFeature(request);
        //log.info("FeatureV2GrpcService multiGetFeature response={}", ProtobufUtils.toJson(response));
        responseObserver.onNext(response);
        responseObserver.onCompleted();
    }

}
