package com.tzld.piaoquan.recommend.feature.service;

import lombok.Data;
import lombok.extern.slf4j.Slf4j;

import java.io.Serializable;
import java.util.List;

/**
 * @author dyp
 */
@Data
@Slf4j
public class DTSConfig implements Serializable {
    private ODPS odps;
    private Redis redis;

    @Data
    public static class ODPS implements Serializable {
        private String table;
        private List<String> cols;
        private List<String> partition;
    }

    @Data
    public static class Redis implements Serializable {
        private String prefix;
        private List<String> key;
        private long expire;
    }

    public boolean selfCheck() {
        if (odps == null) {
            log.error("odps not config");
            return false;
        }
        if (redis == null) {
            log.error("redis not config");
            return false;
        }
        return true;
    }
}
